"""
Django settings for project project.

Generated by 'django-admin startproject' using Django 3.0.8.

For more information on this file, see
https://docs.djangoproject.com/en/3.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.0/ref/settings/
"""

import os
from mongoengine import connect
from datetime import timedelta

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'kj6*k03uw%jj@w10=qtb%a_cg6e$f4_$!9^1p_r995e2ywsrl9'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['cpa-global-wechat.bluewebonline.com', '*']


# Application definition

INSTALLED_APPS = [
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.messages',
    'rest_framework',
    'rest_framework_mongoengine',

    'apps.api_auth',
    'apps.analysis',
    'apps.wechat',
    'apps.user',
    'apps.data_download',
    'apps.event',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'project.middleware.log.ApiLoggingMiddleware'
]

ROOT_URLCONF = 'project.urls'

WSGI_APPLICATION = 'project.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': None,
    }
}

connect(
    # host='mongodb://cpa:YVaRCl3T3MHd9934@dds-2zefd49fbee521541.mongodb.rds.aliyuncs.com:3717,dds-2zefd49fbee521542.mongodb.rds.aliyuncs.com:3717/cpa_global_wechat_construction?replicaSet=mgset-27160077'
    host='mongodb://cpa:YVaRCl3T3MHd9934@ddds-2zefd49fbee521541852-pub.mongodb.rds.aliyuncs.com:3717,dds-2zefd49fbee521542140-pub.mongodb.rds.aliyuncs.com:3717/cpa_global_wechat_construction?replicaSet=mgset-27160077'
)


# Password validation
# https://docs.djangoproject.com/en/3.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Shanghai'

USE_I18N = True

USE_L10N = True

USE_TZ = False


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.0/howto/static-files/

STATIC_URL = '/static/'


REST_FRAMEWORK = {
    'DEFAULT_PAGINATION_CLASS': 'project.utils.pagination.CustomPagination',
    'PAGE_SIZE': 10,
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'apps.api_auth.authentication.TokenAuthentication',
    ),
    'DEFAULT_PERMISSION_CLASSES': [
        'apps.api_auth.permissions.RbacPermission',
    ],
    'DEFAULT_RENDERER_CLASSES': [
        'rest_framework.renderers.JSONRenderer',
    ],
    'DEFAULT_FILTER_BACKENDS': [],
    'EXCEPTION_HANDLER': 'project.utils.exception.custom_exception_handler'
}
AUTHENTICATION_BACKENDS = ['apps.api_auth.backends.ModelBackend']
AUTH_USER_MODEL_MONGODB = 'apps.api_auth.models.AuthUser'

JWT_AUTH = {
    'JWT_EXPIRATION_DELTA': timedelta(days=7),
    'JWT_AUTH_HEADER_PREFIX': 'Bearer'
}

AES = {
    'iv': 'aSEDKOOuic5BDks1',
    'key': '9B1niuSzcISIHV5i',
}


WECHAT = {
    'MINIPROGRAM': {
        'APPID': '',
        'SECRET': ''
    },
    'OFFIACCOUNT': {
        'APPID': 'wx7c33b1edc5934d81',
        'SECRET': 'da0330d7394e1f620b43ccd118646d5e',
        'TOKEN': 'X1GOUqQcLipgwyhVYMPfagGIFqgbDHlF',
        'EncodingAESKey': 'uLVsTEJU6M20Ks1h2Bc9Rh4Y2FGG5IFrLcEhOjtmdqy'
    },
    'redis_client': 'redis://127.0.0.1:6379/0'
}


LOG_DIR = BASE_DIR + "/logs"
LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'standard': {
            'format': '%(asctime)s FuncName:%(funcName)s LINE:%(lineno)d [%(levelname)s]- %(message)s'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
        'verbose': {
            'format': '%(levelname)s %(asctime)s %(module)s %(funcName)s %(message)s'
        },
    },
    'filters': {
        'require_debug_false': {
            '()': 'django.utils.log.RequireDebugFalse'
        }
    },
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'standard'
        },
        'default': {
            'level': 'INFO',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(LOG_DIR, 'info.log'),
            'maxBytes': 1024*1024*102400,   # 102400 MB
            'backupCount': 2,
            'formatter': 'standard',
        },
        'default_debug': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(LOG_DIR, 'debug.log'),
            'maxBytes': 1024*1024*102400,  # 102400 MB
            'backupCount': 2,
            'formatter': 'standard',
        },
        'request_handler': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(LOG_DIR, 'common.log'),
            'maxBytes': 1024*1024*102400,  # 102400 MB
            'backupCount': 2,
            'formatter': 'standard',
        },
        'restful_api': {
            'level': 'DEBUG',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': os.path.join(LOG_DIR, 'api.log'),
            'maxBytes': 1024*1024*102400,  # 102400 MB
            'backupCount': 2,
            'formatter': 'verbose',
        },
    },
    'loggers': {
        'django': {
            'handlers': ['console', 'default_debug'],
            'level': 'INFO',
            'propagate': False
        },
        'django.request': {
            'handlers': ['request_handler'],
            'level': 'INFO',
            'propagate': False
        },
        'common': {
            'handlers': ['default', 'console'],
            'level': 'INFO',
            'propagate': True
        },
        'api': {
            'handlers': ['restful_api'],
            'level': 'INFO',
            'propagate': True
        },
    }
}

EMAIL_BACKEND = 'django.core.mail.backends.smtp.EmailBackend'
EMAIL_USE_TLS = False  # 是否使用TLS安全传输协议(用于在两个通信应用程序之间提供保密性和数据完整性。)
EMAIL_USE_SSL = True  # 是否使用SSL加密，qq企业邮箱要求使用
EMAIL_HOST = 'smtp.126.com'  # 发送邮件的邮箱 的 SMTP服务器，这里用了腾讯企业邮箱
EMAIL_PORT = 465  # 发件箱的SMTP服务器端口
EMAIL_HOST_USER = 'cpaglobal@126.com'  # 发送邮件的邮箱地址
EMAIL_HOST_PASSWORD = 'HVREUQZLSQVTWPKZ'  # 发送邮件的邮箱密码

OSS = {
    'access_key_id': 'LTAI4Fsv96kxGi33PNNUd4z6',
    'access_key_secret': 'qGbegKc3fmVYZ2Z7qowlXCyTq04iTm',
    'endpoint': 'http://oss-cn-beijing.aliyuncs.com',
    'bucket_name': 'test'
}
